unit Main;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls,
  StdCtrls, DBTables, DB, DBCtrls, Grids, DBGrids, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    Table: TTable;
    DataSource1: TDataSource;
    Panel1: TPanel;
    DatabaseListbox: TListBox;
    TableListbox: TListBox;
    Label4: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    IndexListbox: TListBox;
    Label3: TLabel;
    Label5: TLabel;
    Panel4: TPanel;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    BitBtn1: TBitBtn;
    Image1: TImage;
    Image2: TImage;
    procedure TableListboxClick(Sender: TObject);
    procedure DatabaseListboxClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    Procedure OpenTable;
    Procedure CloseTable;
    procedure BitBtn1Click(Sender: TObject);
    procedure IndexListboxClick(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


Procedure TForm1.OpenTable;
begin
  If Table.Active then
    CloseTable;
  Table.Active := TRUE;
  If Table.Active then
  begin
    DataSource1.DataSet := Table;
    DBGrid1.Visible     := TRUE;
  end;
end;


Procedure TForm1.CloseTable;
begin
  Table.Active        := FALSE;
  Datasource1.DataSet := NIL;
  DBGrid1.Visible     := FALSE;
end;


procedure TForm1.TableListboxClick(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  Try
    CloseTable;
    IndexListbox.Clear;
    Table.DatabaseName := DatabaseListbox.Items[DatabaseListbox.ItemIndex];
    Table.TableName := TableListbox.Items[TableListbox.ItemIndex];
    OpenTable;
    Table.GetIndexNames(IndexListbox.Items);
    IndexListBox.ItemIndex := 0;
  Finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.DatabaseListboxClick(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  Try
    CloseTable;
    TableListbox.Clear;
    IndexListbox.Clear;
    Session.GetTableNames(DatabaseListbox.Items[DatabaseListbox.ItemIndex],
      '', True, False, TableListbox.Items);
  Finally
    Screen.Cursor := crDefault;
  end;
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  Session.GetDatabaseNames( DatabaseListbox.Items );
  DBGrid1.Visible     := FALSE;
  DataSource1.DataSet := NIL;
end;


procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  CloseTable;
  Close;
end;

procedure TForm1.IndexListboxClick(Sender: TObject);
begin
  If Table.Active then
    Table.IndexName := IndexListBox.Items[ IndexListBox.ItemIndex ];
end;

end.
