unit Testbed;

interface

uses

   SysUtils,
   WinTypes,
   WinProcs,
   Messages,
   Classes,
   Graphics,
   Controls,
   Forms,
   Dialogs,
   StdCtrls,
   ExtCtrls,
   SafeStr,
   StrClass,
   ContainR, Console;

type
  TSCTestBed = class(TForm)
    FuncLb    : TListbox;
    GroupBox1 : TGroupBox;
    OutConsole: TConsole;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FuncLbClick(Sender: TObject);
  private
     TheFuncList : TRecordContainer;
    { Private declarations }
    PROCEDURE RunTest(fid : WORD);
    PROCEDURE SetupFuncLb;
  public
    { Public declarations }
  end;

var
  SCTestBed: TSCTestBed;

implementation

{$R *.DFM}

{ ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

CONST

   id_Create = 1;
   id_CreateSize = 2;
   id_CreateString =3;
   id_CreateStringNL = 4;
   id_CreateBoolean = 5;
   id_Destroy = 6;
   id_Copy = 7;
   id_CopyFrom = 8;
   id_Clear = 9;
   id_Empty = 10;
   id_Assign = 11;
   id_AssignFrom = 12;
   id_AssignLen = 13;
   id_AssignMid = 14;
   id_AssignNL = 15;
   id_AssignPad = 16;
   id_AssignRight = 17;
   id_AssignTrim = 18;
   id_Append = 19;
   id_AppendBoolean = 20;
   id_AppendByte = 21;
   id_AppendCh = 22;
   id_AppendDIC = 23;
   id_AppendDouble = 24;
   id_AppendDoubleTrim = 25;
   id_AppendExt = 26;
   id_AppendExtTrim = 27;
   id_AppendLen = 28;
   id_AppendLong = 29;
   id_AppendMid = 30;
   id_AppendNL = 31;
   id_AppendPad = 32;
   id_AppendPtr = 33;
   id_AppendReal = 34;
   id_AppendRight = 35;
   id_AppendSIC = 36;
   id_AppendTrim = 37;
   id_AppendWithTab = 38;
   id_NLAppend = 39;
   id_Prepend = 40;
   id_FirstNonSpaceCh = 41;
   id_HasCh = 42;
   id_isCh = 43;
   id_IsFirstCh = 44;
   id_IsLastCh = 45;
   id_LastNonSpaceCh = 46;
   id_RemoveLastCh = 47;
   id_SetCh = 48;
   id_FromBoolean = 49;
   id_FromByte = 50;
   id_FromChar = 51;
   id_FromDouble = 52;
   id_FromDoubleTrim = 53;
   id_FromExt = 54;
   id_FromExtTrim  = 55;
   id_FromLong = 56;
   id_FromPtr = 57;
   id_FromReal = 58;
   id_FromRealTrim = 59;
   id_FromRGB = 60;
   id_HexFromByte = 61;
   id_HexFromLong = 62;
   id_HexFromPtr = 63;
   id_HexFromWord = 64;
   id_ToBoolean = 65;
   id_ToByte = 66;
   id_ToChar = 67;
   id_ToDouble = 68;
   id_ToExt = 69;
   id_ToInteger = 70;
   id_ToLong = 71;
   id_ToReal = 72;
   id_ToRGB = 73;
   id_ToWord = 74;
   id_AppendStr = 75;
   id_UpperCase = 76;
   id_LowerCase = 77;
   id_CompareStr = 78;
   id_CompareText = 79;
   id_AnsiUpperCase = 80;
   id_AnsiLowerCase = 81;
   id_AnsiCompareStr = 82;
   id_AnsiCompareText = 83;
   id_IsValidIdent = 84;
   id_IntToStr = 85;
   id_IntToHex = 86;
   id_StrToInt = 87;
   id_StrToIntDef = 88;
   id_LoadStr = 89;
   id_FmtLoadStr = 90;
   id_Format = 91;
   id_FloatToStr = 92;
   id_FloatToStrF = 93;
   id_FormatFloat = 94;
   id_StrToFloat = 95;
   id_StrCat = 96;
   id_StrComp = 97;
   id_StrCopy = 98;
   id_StrECopy = 99;
   id_StrEnd = 100;
   id_StrIComp = 101;
   id_StrLCat = 102;
   id_StrLIComp = 103;
   id_StrLComp = 104;
   id_StrLCopy = 105;
   id_StrLen = 106;
   id_StrLower = 107;
   id_StrMove = 108;
   id_StrPas = 109;
   id_StrPCopy = 110;
   id_StrPos = 111;
   id_StrRScan = 112;
   id_StrScan = 113;
   id_StrUpper = 114;
   id_Compare = 115;
   id_CompareI = 116;
   id_CompareL = 117;
   id_CompareLI = 118;
   id_CompareLong = 119;
   id_CompareDouble = 120;
   id_CompareExt = 121;
   id_IsSame = 122;
   id_isSameL = 123;
   id_IsSameLI = 124;
   id_Includes = 125;
   id_Within = 126;
   id_Delete = 127;
   id_Insert = 128;
   id_InsertL = 129;
   id_PadCentre = 130;
   id_PadEnd = 131;
   id_PadFront = 132;
   id_RemoveDIC = 133;
   id_RemoveSIC = 134;
   id_Trim = 135;
   id_TrimEnd = 136;
   id_TrimFront = 137;
   id_TrimZero = 138;
   id_FindCmdLine = 139;
   id_FindCmdLineAndParse = 140;
   id_FindCmdLineParam = 141;
   id_AppendStringRes = 142;
   id_LoadStringRes = 143;
   id_ReadIniKeyword = 144;
   id_WriteIniKeyword = 145;
   id_FindIniSectionKeywords = 146;
   id_AddBackSlash = 147;
   id_BuildPathName = 148;
   id_DefaultExtension = 149;
   id_ExpandFileName = 150;
   id_ForceExtension = 151;
   id_HasBackSlash = 152;
   id_HasDrive = 153;
   id_HasExtension = 154;
   id_HasFileName = 155;
   id_HasDirectory = 156;
   id_DirectoryExists = 157;
   id_DriveExists = 158;
   id_FileExists = 159;
   id_JustExtension = 160;
   id_JustFileName = 161;
   id_JustDirectory = 162;
   id_SetCurDir = 163;
   id_ChCount = 164;
   id_FindBetween2Ch = 165;
   id_FindFirst = 166;
   id_FindFirstCh = 167;
   id_FindLast = 168;
   id_FindLastCh = 169;
   id_FindNext = 170;
   id_FindNextCh = 171;
   id_FindPrev = 172;
   id_FindPrevCh = 173;
   id_SubStrCount = 174;
   id_FirstCharToUpper = 175;
   id_IsAlphaNumeric = 176;
   id_ToLower = 177;
   id_ToUpper = 178;
   id_ReplaceAll = 179;
   id_ReplaceFirst = 180;
   id_ReplaceLast = 181;
   id_ReplaceChAll = 182;
   id_ReplaceChFirst = 183;
   id_ReplaceChLast = 184;
   id_FirstParseDelim = 185;
   id_NextParseDelim = 186;
   id_ParseDelimCount = 187;
   id_ParseDelimToList = 188;
   id_ParsePosToList = 189;
   id_SameI          = 190;
   id_JustName       = 191;
   id_FileSplit      = 192;
   id_FindCurrentDir = 193;

{ ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

TYPE

   PFunctionRecord = ^TFunctionRecord;
   TFunctionRecord = RECORD
      Id   : WORD;
      Name : PChar;
   END;

{ ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

procedure TSCTestBed.Button1Click(Sender: TObject);
begin
   Close;
end;

{ ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

procedure TSCTestBed.FormCreate(Sender: TObject);
begin
   { create container to hold id/func name recs }
   TheFuncList := TRecordContainer.Create(SIZEOF(TFunctionRecord));
   SetupFuncLb;
   { clear memo control }
end;

{ ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

{ ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

procedure TSCTestBed.FormClose(Sender: TObject; var Action: TCloseAction);

   { ++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE KillStr(R : PFunctionRecord); FAR;
   BEGIN
      StrDispose(R^.Name);
   END;

   { ++++++++++++++++++++++++++++++++++++++++++++++++++ }

begin
   TheFuncList.ForEach(@KillStr);
   TheFuncList.Free;
end;

{ ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

PROCEDURE TScTestbed.SetupFuncLb;
VAR
   SObj : TStringClass;

   { ++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE AddItem(id : INTEGER; AStr : PChar);
   VAR
      R : PFunctionRecord;
   BEGIN
      FuncLb.Items.Add(StrPas(AStr));
      NEW(R);
      R^.Id := id;
      R^.Name := StrNew(AStr);
      TheFuncList.Add(R);
   END;

   { ++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

BEGIN
   SObj := TSTringClass.Create;
   AddItem(id_Create,'CONSTRUCTOR Create');
   AddItem(id_CreateSize,'CONSTRUCTOR CreateSize(AMaxSize: WORD)');
   AddItem(id_CreateString,'CONSTRUCTOR CreateString(CONST Args : ARRAY OF CONST)');
   AddItem(id_CreateStringNL,'CONSTRUCTOR CreateStringNL(CONST Args : ARRAY OF CONST)');
   AddItem(id_CreateBoolean,'CONSTRUCTOR CreateBoolean(B : BOOLEAN; StrType : INTEGER)');
   AddItem(id_Destroy,'DESTRUCTOR Destroy');
   AddItem(id_Copy,'FUNCTION Copy : POINTER; VIRTUAL');
   AddItem(id_CopyFrom,'PROCEDURE CopyFrom(Source : TStringClass)');
   AddItem(id_Clear,'PROCEDURE Clear');
   AddItem(id_Empty,'PROCEDURE Empty');
   AddItem(id_Assign,'FUNCTION Assign(CONST Args : ARRAY OF CONST) : PChar');
   AddItem(id_AssignFrom,'FUNCTION AssignFrom(CONST Args : ARRAY OF CONST; Start : WORD) : PChar');
   AddItem(id_AssignLen,'FUNCTION AssignLen(CONST Args : ARRAY OF CONST; Len : WORD) : PChar;');
   AddItem(id_AssignMid,'FUNCTION AssignMid(CONST Args : ARRAY OF CONST; Start,Count : WORD) : PChar');
   AddItem(id_AssignNL,'FUNCTION AssignNL(CONST Args : ARRAY OF CONST) : PChar');
   AddItem(id_AssignPad,'FUNCTION AssignPad(CONST Args : ARRAY OF CONST; Len : WORD; ACh : CHAR) : PChar');
   AddItem(id_AssignRight,'FUNCTION AssignRight(CONST Args : ARRAY OF CONST; Len : WORD) : PChar;');
   AddItem(id_AssignTrim,'FUNCTION AssignTrim(CONST Args : ARRAY OF CONST) : PChar;');
   AddItem(id_Append,'FUNCTION Append(CONST Args : ARRAY OF CONST) : PChar;');
   AddItem(id_AppendBoolean,'FUNCTION AppendBoolean(B : BOOLEAN; bt : INTEGER) : PChar;');
   AddItem(id_AppendByte,'FUNCTION AppendByte(B : BYTE) : PChar;');
   AddItem(id_AppendCh,'FUNCTION AppendCh(C : CHAR) : PChar;');
   AddItem(id_AppendDIC,'FUNCTION AppendDIC(CONST Args : ARRAY OF CONST) : PChar;');
   AddItem(id_AppendDouble,'FUNCTION AppendDouble(D : DOUBLE; Width,Places : BYTE) : PChar;');
   AddItem(id_AppendDoubleTrim,'FUNCTION AppendDoubleTrim(D : DOUBLE) : PChar;');
   AddItem(id_AppendExt,'FUNCTION AppendExt(E : EXTENDED; Width,Places : BYTE) : PChar;');
   AddItem(id_AppendExtTrim,'FUNCTION AppendExtTrim(E : EXTENDED) : PChar;');
   AddItem(id_AppendLen,'FUNCTION AppendLen(CONST Args : ARRAY OF CONST; Len : WORD) : PChar;');
   AddItem(id_AppendLong,'FUNCTION AppendLong(L : LONGINT) : PChar;');
   AddItem(id_AppendMid,'FUNCTION AppendMid(CONST Args : ARRAY OF CONST; Start,Count : WORD) : PChar;');
   AddItem(id_AppendNL,'FUNCTION AppendNL(CONST Args : ARRAY OF CONST) : PChar;');
   AddItem(id_AppendPad,'FUNCTION AppendPad(CONST Args : ARRAY OF CONST; Len : WORD; ACh : CHAR) : PChar;');
   AddItem(id_AppendPtr,'FUNCTION AppendPtr(P : POINTER) : PChar;');
   AddItem(id_AppendReal,'FUNCTION AppendReal(R : REAL; Width,Places : BYTE) : PChar;');
   AddItem(id_AppendRight,'FUNCTION AppendRight(CONST Args : ARRAY OF CONST; Len : WORD) : PChar;');
   AddItem(id_AppendSIC,'FUNCTION AppendSIC(CONST Args : ARRAY OF CONST) : PChar;');
   AddItem(id_AppendTrim,'FUNCTION AppendTrim(CONST Args : ARRAY OF CONST) : PChar;');
   AddItem(id_AppendWithTab,'FUNCTION AppendWithTab(CONST Args : ARRAY OF CONST) : PChar;');
   AddItem(id_NLAppend,'FUNCTION NLAppend(CONST Args : ARRAY OF CONST) : PChar;');
   AddItem(id_Prepend,'FUNCTION Prepend(CONST Args : ARRAY OF CONST) : PChar;');
   AddItem(id_FirstNonSpaceCh,'FUNCTION FirstNonSpaceCh(VAR ACh : CHAR) : WORD;');
   AddItem(id_HasCh,'FUNCTION HasCh(ACh : CHAR; VAR Pos : WORD) : BOOLEAN;');
   AddItem(id_isCh,'FUNCTION IsCh(W : WORD; ACh : CHAR) : BOOLEAN;');
   AddItem(id_IsFirstCh,'FUNCTION IsFirstCh(ACh : CHAR) : BOOLEAN;');
   AddItem(id_IsLastCh,'FUNCTION IsLastCh(ACh : CHAR) : BOOLEAN;');
   AddItem(id_LastNonSpaceCh,'FUNCTION LastNonSpaceCh(VAR ACh : CHAR) : WORD;');
   AddItem(id_RemoveLastCh,'PROCEDURE RemoveLastCh');
   AddItem(id_SetCh,'PROCEDURE SetCh(W : WORD; ACh : CHAR');
   { *** WITH OTHER DATA TYPES *** }
   AddItem(id_FromBoolean,'FUNCTION FromBoolean(B : BOOLEAN; bt : INTEGER) : PChar;');
   AddItem(id_FromByte,'FUNCTION FromByte(B : BYTE) : PChar;');
   AddItem(id_FromChar,'FUNCTION FromChar(C : CHAR) : PChar;');
   AddItem(id_FromDouble,'FUNCTION FromDouble(D : DOUBLE; Width,Places : BYTE) : PChar;');
   AddItem(id_FromDoubleTrim,'FUNCTION FromDoubleTrim(D : DOUBLE) : PChar;');
   AddItem(id_FromExt,'FUNCTION FromExt(E : EXTENDED; Width,Places : BYTE) : PChar;');
   AddItem(id_FromExtTrim,'FUNCTION FromExtTrim(E : EXTENDED) : PChar;');
   AddItem(id_FromLong,'FUNCTION FromLong(L : LONGINT) : PChar;');
   AddItem(id_FromPtr,'FUNCTION FromPtr(P : POINTER) : PChar;');
   AddItem(id_FromReal,'FUNCTION FromReal(R : REAL; Width,Places : BYTE) : PChar;');
   AddItem(id_FromRealTrim,'FUNCTION FromRealTrim(R : REAL) : PChar;');
   AddItem(id_FromRGB,'FUNCTION FromRGB(C : TColorRef) : PChar;');
   AddItem(id_HexFromByte,'FUNCTION HexFromByte(B : BYTE) : PChar;');
   AddItem(id_HexFromLong,'FUNCTION HexFromLong(L : LONGINT) : PChar;');
   AddItem(id_HexFromPtr,'FUNCTION HexFromPtr(P : POINTER) : PChar;');
   AddItem(id_HexFromWord,'FUNCTION HexFromWord(W : WORD) : PChar;');
   AddItem(id_ToBoolean,'FUNCTION ToBoolean(VAR B : BOOLEAN) : BOOLEAN;');
   AddItem(id_ToByte,'FUNCTION ToByte(VAR B : BYTE) : BOOLEAN;');
   AddItem(id_ToChar,'FUNCTION ToChar(VAR C : CHAR) : BOOLEAN;');
   AddItem(id_ToDouble,'FUNCTION ToDouble(VAR D : DOUBLE) : BOOLEAN;');
   AddItem(id_ToExt,'FUNCTION ToExt(VAR E : EXTENDED) : BOOLEAN;');
   AddItem(id_ToInteger,'FUNCTION ToInteger(VAR I : INTEGER) : BOOLEAN;');
   AddItem(id_ToLong,'FUNCTION ToLong(VAR L : LONGINT) : BOOLEAN;');
   AddItem(id_ToReal,'FUNCTION ToReal(VAR R : REAL) : BOOLEAN;');
   AddItem(id_ToRGB,'FUNCTION ToRGB(VAR C : TColorRef) : BOOLEAN;');
   AddItem(id_ToWord,'FUNCTION ToWord(VAR W : WORD) : BOOLEAN;');
   AddItem(id_AppendStr,'FUNCTION AppendStr(CONST S: string) : PChar;');
   AddItem(id_UpperCase,'FUNCTION UpperCase(CONST S: string) : PChar;');
   AddItem(id_LowerCase,'FUNCTION LowerCase(const S: string): PChar;');
   AddItem(id_CompareStr,'FUNCTION CompareStr(CONST S2: STRING): Integer;');
   AddItem(id_CompareText,'FUNCTION CompareText(CONST S2: STRING): Integer;');
   AddItem(id_AnsiUpperCase,'FUNCTION AnsiUpperCase(CONST S : STRING) : PChar;');
   AddItem(id_AnsiLowerCase,'FUNCTION AnsiLowerCase(CONST S : STRING) : PChar;');
   AddItem(id_AnsiCompareStr,'FUNCTION AnsiCompareStr(CONST S2: STRING): Integer;');
   AddItem(id_AnsiCompareText,'FUNCTION AnsiCompareText(CONST S2: STRING): Integer;');
   AddItem(id_IsValidIdent,'FUNCTION IsValidIdent: Boolean;');
   AddItem(id_IntToStr,'FUNCTION IntToStr(Value: Longint): PChar;');
   AddItem(id_IntToHex,'FUNCTION IntToHex(Value: Longint; Digits: Integer): PChar;');
   AddItem(id_StrToInt,'FUNCTION StrToInt : Longint;');
   AddItem(id_StrToIntDef,'FUNCTION StrToIntDef(Default: Longint): Longint;');
   AddItem(id_LoadStr,'FUNCTION LoadStr(Ident: Word): PChar;');
   AddItem(id_FmtLoadStr,'FUNCTION FmtLoadStr(Ident: Word; CONST Args: ARRAY OF CONST): PChar;');
   AddItem(id_Format,'FUNCTION Format(CONST Format: STRING; CONST Args: ARRAY OF CONST): PChar;');
   AddItem(id_FloatToStr,'FUNCTION FloatToStr(Value: Extended): PChar;');
   AddItem(id_FloatToStrF,'FUNCTION FloatToStrF(Value: Extended; Format: TFloatFormat; Precision, Digits: Integer): PChar;');
   AddItem(id_FormatFloat,'FUNCTION FormatFloat(const Format: STRING; Value: Extended): PChar;');
   AddItem(id_StrToFloat,'FUNCTION StrToFloat : Extended;');
   AddItem(id_StrCat,'FUNCTION StrCat(Source : PChar) : PChar;');
   AddItem(id_StrComp,'FUNCTION StrComp(Str2 : PChar) : INTEGER;');
   AddItem(id_StrCopy,'FUNCTION StrCopy(Source : PChar) : PChar;');
   AddItem(id_StrECopy,'FUNCTION StrECopy(Source : PChar) : PChar;');
   AddItem(id_StrEnd,'FUNCTION StrEnd : PChar;');
   AddItem(id_StrIComp,'FUNCTION StrIComp(Str2 : PChar) : INTEGER;');
   AddItem(id_StrLCat,'FUNCTION StrLCat(Source : PChar; MaxLen : WORD) : PChar;');
   AddItem(id_StrLIComp,'FUNCTION StrLIComp(Str2 : PChar; MaxLen : WORD) : INTEGER;');
   AddItem(id_StrLComp,'FUNCTION StrLComp(Str2 : PChar; MaxLen : WORD) : INTEGER;');
   AddItem(id_StrLCopy,'FUNCTION StrLCopy(Str2 : PChar; MaxLen : WORD) : INTEGER;');
   AddItem(id_StrLen,'FUNCTION StrLen : WORD;');
   AddItem(id_StrLower,'FUNCTION StrLower : PChar;');
   AddItem(id_StrMove,'FUNCTION StrMove(Source : PChar; Count : WORD) : PChar;');
   AddItem(id_StrPas,'FUNCTION StrPas : STRING;');
   AddItem(id_StrPCopy,'FUNCTION StrPCopy(Source : STRING) : PChar;');
   AddItem(id_StrPos,'FUNCTION StrPos(Str2 : PChar) : PChar;');
   AddItem(id_StrRScan,'FUNCTION StrRScan(Chr : CHAR) : PChar;');
   AddItem(id_StrScan,'FUNCTION StrScan(Chr : CHAR) : PChar;');
   AddItem(id_StrUpper,'FUNCTION StrUpper : PChar;');
   AddItem(id_Compare,'FUNCTION Compare(CONST Args : ARRAY OF CONST) : INTEGER;');
   AddItem(id_CompareI,'FUNCTION CompareI(CONST Args : ARRAY OF CONST) : INTEGER;');
   AddItem(id_CompareL,'FUNCTION CompareL(CONST Args : ARRAY OF CONST; Len : WORD) : INTEGER;');
   AddItem(id_CompareLI,'FUNCTION CompareLI(CONST Args : ARRAY OF CONST; Len : WORD) : INTEGER;');
   AddItem(id_CompareLong,'FUNCTION CompareLong(L : LONGINT) : INTEGER;');
   AddItem(id_CompareDouble,'FUNCTION CompareDouble(D : DOUBLE) : INTEGER;');
   AddItem(id_CompareExt,'FUNCTION CompareExt(D : DOUBLE) : INTEGER;');
   AddItem(id_IsSame,'FUNCTION IsSame(CONST Args : ARRAY OF CONST) : BOOLEAN;');
   AddItem(id_isSameL,'FUNCTION IsSameL(CONST Args : ARRAY OF CONST; Len : WORD) : BOOLEAN;');
   AddItem(id_IsSameLI,'FUNCTION IsSameLI(CONST Args : ARRAY OF CONST; Len : WORD) : BOOLEAN;');
   AddItem(id_Includes,'FUNCTION Includes(CONST Args : ARRAY OF CONST) : BOOLEAN;');
   AddItem(id_Within,'FUNCTION Within(CONST Args : ARRAY OF CONST) : BOOLEAN;');
   AddItem(id_Delete,'FUNCTION Delete(Index,Count : WORD) : PChar;');
   AddItem(id_Insert,'FUNCTION Insert(CONST Args : ARRAY OF CONST; Index : WORD) : PChar;');
   AddItem(id_InsertL,'FUNCTION InsertL(CONST Args : ARRAY OF CONST; Len,Index : WORD) : PChar;');
   AddItem(id_PadCentre,'FUNCTION PadCentre(NewLen : WORD; ACh : CHAR) : PChar;');
   AddItem(id_PadEnd,'FUNCTION PadEnd(NewLen : WORD; ACh : CHAR) : PChar;');
   AddItem(id_PadFront,'FUNCTION PadFront(NewLen : WORD; ACh : CHAR) : PChar;');
   AddItem(id_RemoveDIC,'FUNCTION RemoveDIC : PChar;');
   AddItem(id_RemoveSIC,'FUNCTION RemoveSIC : PChar;');
   AddItem(id_Trim,'FUNCTION Trim : PChar;');
   AddItem(id_TrimEnd,'FUNCTION TrimEnd : PChar;');
   AddItem(id_TrimFront,'FUNCTION TrimFront : PChar;');
   AddItem(id_TrimZero,'FUNCTION TrimZero : PChar;');
   AddItem(id_FindCmdLine,'FUNCTION FindCmdLine : PChar;');
   AddItem(id_FindCmdLineAndParse,
           'FUNCTION FindCmdLineAndParse(IncExeParam : BOOLEAN;VAR AList   : TObjectContainer) : PChar');
   AddItem(id_FindCmdLineParam,'FUNCTION FindCmdLineParam(Idx : INTEGER) : PChar;');
   AddItem(id_AppendStringRes,'FUNCTION AppendStringRes(Instance : THandle; Id : WORD) : PChar;');
   AddItem(id_LoadStringRes,'FUNCTION LoadStringRes(Instance : THandle; Id : WORD) : PChar;');
   AddItem(id_ReadIniKeyword,
           'FUNCTION ReadIniKeyword(CONST IniFileArgs,SectionArgs,KeyWordArgs : ARRAY OF CONST) : WORD;');
   AddItem(id_WriteIniKeyword,'FUNCTION WriteIniKeyword(CONST IniFileArgs,SectionArgs,KeyWordArgs : ARRAY OF CONST) : WORD;');
   AddItem(id_FindIniSectionKeywords,
 'FUNCTION FindIniSectionKeywords(CONST IniFileArgs,SectionArgs  : ARRAY OF CONST; VAR AList : TObjectContainer) : WORD;');
   AddItem(id_AddBackSlash,'FUNCTION AddBackSlash : PChar;');
   AddItem(id_BuildPathName,'FUNCTION BuildPathName(CONST DirArgs,FileNameArgs,ExtArgs : ARRAY OF CONST) : PChar;');
   AddItem(id_DefaultExtension,'FUNCTION DefaultExtension(CONST Args : ARRAY OF CONST) : PChar;');
   AddItem(id_ExpandFileName,'FUNCTION ExpandFileName : PChar;');
   AddItem(id_FindCurrentDir,'FUNCTION FindCurrentDir : PChar;');
   AddItem(id_ForceExtension,'FUNCTION ForceExtension(CONST Args : ARRAY OF CONST) : PChar;');
   AddItem(id_HasBackSlash,'FUNCTION HasBackSlash : BOOLEAN;');
   AddItem(id_HasDrive,'FUNCTION HasDrive : BOOLEAN;');
   AddItem(id_HasExtension,'FUNCTION HasExtension(VAR DotPos : WORD) : BOOLEAN;');
   AddItem(id_HasFileName,'FUNCTION HasFileName : BOOLEAN;');
   AddItem(id_HasDirectory,'FUNCTION HasDirectory : BOOLEAN;');
   AddItem(id_DirectoryExists,'FUNCTION DirectoryExists : BOOLEAN;');
   AddItem(id_DriveExists,'FUNCTION DriveExists : BOOLEAN;');
   AddItem(id_FileExists,'FUNCTION FileExists : BOOLEAN;');
   AddItem(id_FileSplit,'FUNCTION FileSplit(VAR ADirObj,ANameObj,AnExtObj : TStringClass) : WORD;');
   AddItem(id_JustExtension,'FUNCTION JustExtension(CONST Args : ARRAY OF CONST) : PChar;');
   AddItem(id_JustFileName,'FUNCTION JustFileName(CONST Args : ARRAY OF CONST) : PChar;');
   AddItem(id_JustName,'FUNCTION JustName(CONST Args : ARRAY OF CONST) : PChar;');
   AddItem(id_JustDirectory,'FUNCTION JustDirectory(CONST Args : ARRAY OF CONST) : PChar;');
   AddItem(id_SetCurDir,'FUNCTION SetCurDir : BOOLEAN;');
   AddItem(id_ChCount,'FUNCTION ChCount(ACh : CHAR) : WORD;');
   SObj.Assign(['FUNCTION FindBetween2Ch(FCh,SCh : CHAR; Start : WORD; ',
                'VAR SubStart,SubrLen : WORD; Cut,IncDelims : BOOLEAN;',
                'VAR ASubStr : TStringClass) : BOOLEAN;']);
   AddItem(id_FindBetween2Ch,SObj.ZString);
   AddItem(id_FindFirst,
          'FUNCTION FindFirst(CONST SubArgs : ARRAY OF CONST; VAR P : WORD) : BOOLEAN;');
   AddItem(id_FindFirstCh,'FUNCTION FindFirstCh(ACh : CHAR; VAR P : WORD) : BOOLEAN;');
   AddItem(id_FindLast,'FUNCTION FindLast(CONST SubArgs : ARRAY OF CONST; VAR P : WORD) : BOOLEAN;');
   AddItem(id_FindLastCh,'FUNCTION FindLastCh(ACh : CHAR; VAR P : WORD) : BOOLEAN;');
   AddItem(id_FindNext,'FUNCTION FindNext(CONST SubArgs : ARRAY OF CONST; StartPos : WORD; VAR NextPos : WORD) : BOOLEAN;');
   AddItem(id_FindNextCh,'FUNCTION FindNextCh(ACh : CHAR; StartPos : WORD; VAR NextPos : WORD) : BOOLEAN;');
   AddItem(id_FindPrev,'FUNCTION FindPrev(CONST SubArgs : ARRAY OF CONST; StartPos : WORD; VAR PrevPos : WORD) : BOOLEAN;');
   AddItem(id_FindPrevCh,'FUNCTION FindPrevCh(ACh : CHAR; StartPos : WORD; VAR PrevPos : WORD) : BOOLEAN;');
   AddItem(id_SubStrCount,'FUNCTION SubStrCount(CONST SubArgs : ARRAY OF CONST) : WORD;');
   AddItem(id_FirstCharToUpper,'FUNCTION FirstCharToUpper : PChar;');
   AddItem(id_IsAlphaNumeric,'FUNCTION IsAlphaNumeric : BOOLEAN;');
   AddItem(id_ToLower,'FUNCTION ToLower : PChar;');
   AddItem(id_ToUpper,'FUNCTION ToUpper : PChar;');
   AddItem(id_ReplaceAll,'FUNCTION ReplaceAll(CONST OldArgs,NewArgs : ARRAY OF CONST) : PChar;');
   AddItem(id_ReplaceFirst,'FUNCTION ReplaceFirst(CONST OldArgs,NewArgs : ARRAY OF CONST) : PChar;');
   AddItem(id_ReplaceLast,'FUNCTION ReplaceLast(CONST OldArgs,NewArgs : ARRAY OF CONST) : PChar;');
   AddItem(id_ReplaceChAll,'FUNCTION ReplaceChAll(OldCh,NewCh : CHAR) : PChar;');
   AddItem(id_ReplaceChFirst,'FUNCTION ReplaceChFirst(OldCh,NewCh : CHAR) : PChar;');
   AddItem(id_ReplaceChLast,'FUNCTION ReplaceChLast(OldCh,NewCh : CHAR) : PChar;');
   AddItem(id_FirstParseDelim,
   'FUNCTION FirstParseDelim(CONST Args : ARRAY OF CONST; DelimCh : CHAR; VAR DelimPos : WORD) : BOOLEAN;');
   SObj.Assign(['FUNCTION NextParseDelim(CONST Args : ARRAY OF CONST; DelimCh : CHAR; ',
                'StartPos : WORD; VAR NextDelimPos : WORD) : BOOLEAN;']);
   AddItem(id_NextParseDelim,SObj.ZString);
   AddItem(id_ParseDelimCount,'FUNCTION ParseDelimCount(DelimCh : CHAR) : WORD;');
   AddItem(id_ParseDelimToList,
    'FUNCTION ParseDelimToList(DelimCh : CHAR; Special : INTEGER; VAR AList : TObjectContainer) : WORD;');
   AddItem(id_ParsePosToList,'FUNCTION ParsePosToList(VAR PosArray; PosCt : WORD; VAR AList : TObjectContainer) : WORD;');
   { remove any sel }
   FuncLb.ItemIndex := -1;
   { end }
   SObj.Free;
END;

{ ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

procedure TSCTestBed.FuncLbClick(Sender: TObject);
CONST
   MaxLen = 500;
VAR
   AStr : PChar;
   AnItem : PFunctionRecord;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   FUNCTION MatchStr(R : PFunctionRecord) : BOOLEAN; FAR;
   BEGIN
      MatchStr := (SafeStrIComp(AStr,R^.Name) = 0);
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

begin
   GetMem(AStr,Maxlen);
   StrPCopy(AStr,FuncLb.Items.Strings[FuncLb.ItemIndex]);
   AnItem := TheFuncList.FirstThat(@MatchStr);
   IF AnItem <> NIL THEN
      RunTest(AnItem^.Id);
   FreeMem(AStr,Maxlen);

end;

{ ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

PROCEDURE TScTestBed.RunTest(fid : WORD);
CONST
   ANullPChar : PChar = NIL;
   APChar : PChar = 'PChar string';
   AStr : STRING = 'Pascal string';
   ANullStr : STRING = '';
   ALong : LONGINT = 99000;
   APath : STRING = 'c:\windows\system.ini';
   AReal : REAL = 21.3;
   AnInteger : INTEGER = -5;
   AWord : WORD = 66;
   ADouble : DOUBLE = 66.4;
   AByte : BYTE = 124;
   AnExt : EXTENDED = 134.456;

VAR
   ANullStrObj,AStrObj : TStringClass;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoCreate;
   BEGIN
      Writeln('Instantiates an object with null string and zero buffer length');
      Writeln('e.g. AStrObj := TStringClass.Create');
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoCreateSize;
   BEGIN
      Writeln('Instantiates an object with a null string but with a buffer');
      Writeln(' size preset to ''ASize'' bytes. Useful for situations ');
      Writeln('where lots of assigns/appends are anticipated.');
      Writeln('e.g. AStrObj := TStringClass.CreateSize(2000)');
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoCreateString;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr,''.'',APChar,''.'',ANullPChar,''.'']);');
      TObj := TStringClass.CreateString([AStr,'.',APChar,'.',ANullPChar,'.']);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoCreateStringNL;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateStringNL([AStr]);');
      Writeln('TObj.Append([APChar]);');
      TObj := TStringClass.CreateStringNL([AStr]);
      TObj.Append([APChar]);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoCreateBoolean;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateBoolean(TRUE,bt_NoYes);');
      TObj := TStringClass.CreateBoolean(TRUE,bt_NoYes);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoDestroy;
   BEGIN
      Writeln('Disposes the string class object.');
      Writeln('Do not call directly. Use the Free metheod');
   END;
   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoCopy;
   VAR
      TObj,CObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr]);');
      Writeln('CObj := TObj.Copy;');
      TObj := TStringClass.CreateString([AStr]);
      CObj := TObj.Copy;
      Writeln;
      Writeln('Result:');
      Writeln('Original string object text = ',TObj.ZString);
      Writeln('Copy string object text     = ',CObj.ZString);
      TObj.Free;
      CObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoCopyFrom;
   VAR
      TObj,CObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr]);');
      Writeln('CObj := TStringClass.Create;');
      Writeln('CObj.CopyFrom(TObj);');
      TObj := TStringClass.CreateString([AStr]);
      CObj := TStringClass.Create;
      CObj.CopyFrom(TObj);
      Writeln;
      Writeln('Result:');
      Writeln('Original string object text = ',TObj.ZString);
      Writeln('Copy string object text     = ',CObj.ZString);
      TObj.Free;
      CObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoClear;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr]);');
      Writeln('TObj.Clear;');
      TObj := TStringClass.CreateString([AStr]);
      Writeln;
      Writeln('Result pre clear :');
      Writeln(TObj.ZString,'(Buffer Size = ',TObj.MaxSize,')');
      TObj.Clear;
      Writeln;
      Writeln('Result post clear :');
      Writeln(TObj.ZString,'(Buffer Size = ',TObj.MaxSize,')');
      Writeln;
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoEmpty;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr]);');
      Writeln('TObj.Empty;');
      TObj := TStringClass.CreateString([AStr]);
      Writeln;
      Writeln('Result pre Empty :');
      Writeln(TObj.ZString,'(Buffer Size = ',TObj.MaxSize,')');
      TObj.Empty;
      Writeln;
      Writeln('Result post Empty :');
      Writeln(TObj.ZString,'(Buffer Size = ',TObj.MaxSize,')');
      Writeln;
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAssign;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.Assign([AStr,'' and '',APChar,'' '',ALong]);');
      TObj := TStringClass.Create;
      TObj.Assign([AStr,' and ',APChar,' ',ALong]);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAssignFrom;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.AssignFrom([AStr,'' and '',APChar,'' '',ALong],7);');
      TObj := TStringClass.Create;
      TObj.AssignFrom([AStr,' and ',APChar,' ',ALong],7);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAssignLen;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.AssignLen([AStr,'' and '',APChar,'' '',ALong],9);');
      TObj := TStringClass.Create;
      TObj.AssignLen([AStr,' and ',APChar,' ',ALong],9);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAssignMid;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.AssignMid([AStr,'' and '',APChar,'' '',ALong],7,5);');
      TObj := TStringClass.Create;
      TObj.AssignMid([AStr,' and ',APChar,' ',ALong],7,5);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAssignNL;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.AssignNL([AStr,'' and '',APChar,'' '',ALong]);');
      Writeln('TObj.Append([AWord]);');
      TObj := TStringClass.Create;
      TObj.AssignNL([AStr,' and ',APChar,' ',ALong]);
      TObj.Append([AWord]);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAssignPad;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.AssignPad([AStr],15,''x'');');
      TObj := TStringClass.Create;
      TObj.AssignPad([AStr],15,'x');
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAssignRight;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.AssignRight([AStr],3);');
      TObj := TStringClass.Create;
      TObj.AssignRight([AStr],3);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAssignTrim;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.AssignTrim([''    '',AStr,''   '']);');
      TObj := TStringClass.Create;
      TObj.AssignTrim(['    ',AStr,'   ']);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppend;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr]);');
      Writeln('TObj.Append([APChar,'' '',ADouble]);');
      TObj := TStringClass.CreateString([AStr]);
      TObj.Append([APChar,' ',ADouble]);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendBoolean;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr,'' = '']);');
      Writeln('TObj.AppendBoolean(FALSE,bt_FalseTrue);');
      TObj := TStringClass.CreateString([AStr,' = ']);
      TObj.AppendBoolean(FALSE,bt_FalseTrue);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendByte;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr,'' = '']);');
      Writeln('TObj.AppendByte(AByte);');
      TObj := TStringClass.CreateString([AStr,' = ']);
      TObj.AppendByte(AByte);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendCh;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr]);');
      Writeln('TObj.AppendCh(''*'');');
      TObj := TStringClass.CreateString([AStr]);
      TObj.AppendCh('*');
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendDIC;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([''Call me '']);');
      Writeln('TObj.AppendDIC([''Mr Tibbs'']);');
      TObj := TStringClass.CreateString(['Call me ']);
      TObj.AppendDIC(['Mr Tibbs']);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendDouble;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([''Value =  '']);');
      Writeln('TObj.AppendDouble(ADouble,10,3);');
      TObj := TStringClass.CreateString(['Value =  ']);
      TObj.AppendDouble(ADouble,10,3);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendDoubleTrim;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([''Value =  '']);');
      Writeln('TObj.AppendDoubleTrim(ADouble);');
      TObj := TStringClass.CreateString(['Value =  ']);
      TObj.AppendDoubleTrim(ADouble);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendExt;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([''Value =  '']);');
      Writeln('TObj.AppendExt(AnExt,10,3);');
      TObj := TStringClass.CreateString(['Value =  ']);
      TObj.AppendExt(AnExt,10,3);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendExtTrim;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([''Value =  '']);');
      Writeln('TObj.AppendExtTrim(AnExt);');
      TObj := TStringClass.CreateString(['Value =  ']);
      TObj.AppendExtTrim(AnExt);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendLen;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr]);');
      Writeln('TObj.AppendLen([APChar],4);');
      TObj := TStringClass.CreateString([AStr]);
      TObj.AppendLen([APChar],4);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendLong;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr]);');
      Writeln('TObj.AppendLong(ALong);');
      TObj := TStringClass.CreateString([AStr]);
      TObj.AppendLong(ALong);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendMid;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr]);');
      Writeln('TObj.AppendMid([APChar],3,2);');
      TObj := TStringClass.CreateString([AStr]);
      TObj.AppendMid([APChar],3,2);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendNL;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.AppendNL([''1st line'']);');
      Writeln('TObj.Append([''2nd line'']);');
      TObj := TStringClass.Create;
      TObj.AppendNL(['1st line']);
      TObj.Append(['2nd line']);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendPad;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr]);');
      Writeln('TObj.AppendPad([APChar],30,''?'');');
      TObj := TStringClass.CreateString([AStr]);
      TObj.AppendPad([APChar],30,'?');
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendPtr;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([''ALong Pointer = '']);');
      Writeln('TObj.AppendPtr(@ALong);');
      TObj := TStringClass.CreateString(['ALong Pointer = ']);
      TObj.AppendPtr(@ALong);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendReal;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([''AReal = '']);');
      Writeln('TObj.AppendReal(AReal,10,2);');
      TObj := TStringClass.CreateString(['AReal = ']);
      TObj.AppendReal(AReal,10,2);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendRight;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr]);');
      Writeln('TObj.AppendRight([APChar],3);');
      TObj := TStringClass.CreateString([AStr]);
      TObj.AppendRight([APChar],3);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendSIC;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([''Call me '']);');
      Writeln('TObj.AppendSIC([''Mr Tibbs'']);');
      TObj := TStringClass.CreateString(['Call me ']);
      TObj.AppendSIC(['Mr Tibbs']);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendTrim;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([''Call me '']);');
      Writeln('TObj.AppendTrim([''       Mr Tibbs        '']);');
      TObj := TStringClass.CreateString(['Call me ']);
      TObj.AppendTrim(['       Mr Tibbs        ']);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoAppendWithTab;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.AppendWithTab([''First'']);');
      Writeln('TObj.Append([''Second'']);');
      TObj := TStringClass.Create;
      TObj.AppendWithTab(['First']);
      TObj.Append(['Second']);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoNLAppend;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr]);');
      Writeln('TObj.NLAppend([APChar]);');
      TObj := TStringClass.CreateString([AStr]);
      TObj.NLAppend([APChar]);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoPrepend;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr]);');
      Writeln('TObj.Prepend([APChar]);');
      TObj := TStringClass.CreateString([AStr]);
      TObj.Prepend([APChar]);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoFirstNonSpaceCh;
   VAR
      TObj : TStringClass;
      w : WORD;
      ACh : CHAR;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([''      '',AStr]);');
      Writeln('w := TObj.FirstNonSpaceCh(ACh);');
      TObj := TStringClass.CreateString(['      ',AStr]);
      w := TObj.FirstNonSpaceCh(ACh);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      Writeln('First non space char at base zero position ',w,' and is a ',ACh,' character');
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoHasCh;
   VAR
      TObj : TStringClass;
      w : WORD;
      ACh : CHAR;
      b : boolean;
   BEGIN
      Writeln('Code:');
      Writeln('ACh := ''c'';');
      Writeln('TObj := TStringClass.CreateString([AStr]);');
      Writeln('b := TObj.HasCh(ACh,w);');
      ACh := 'c';
      TObj := TStringClass.CreateString([AStr]);
      b := TObj.HasCh(ACh,w);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      IF b THEN
      BEGIN
         Write('Character ',ACh,' is found within the string');
         Writeln(' at position ',w);
      END
      ELSE
         Writeln('Character ',ACh,' is NOT found within the string');
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoIsCh;
   VAR
      TObj : TStringClass;
      w : WORD;
      ACh : CHAR;
      b : boolean;
   BEGIN
      Writeln('Code:');
      Writeln('ACh := ''c'';');
      Writeln('TObj := TStringClass.CreateString([AStr]);');
      Writeln('b := TObj.IsCh(3,ACh);');
      ACh := 'c';
      TObj := TStringClass.CreateString([AStr]);
      b := TObj.IsCh(3,ACh);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      IF b THEN
      BEGIN
         Writeln('Character ',ACh,' is found at position 3');
      END
      ELSE
         Writeln('Character ',ACh,' is NOT found at position 3');
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoFromRGB;
   VAR
      TObj : TStringClass;
      C : TColorRef;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('C := RGB(255,255,0);');
      Writeln('TObj.FromRGB(C);');
      TObj := TStringClass.Create;
      C := RGB(255,255,0);
      TObj.FromRGB(C);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoFindCmdLine;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.FindCmdLine;');
      TObj := TStringClass.Create;
      TObj.FindCmdLine;
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoJustExtension;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.JustExtension([APath]);');
      TObj := TStringClass.Create;
      TObj.JustExtension([APath]);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoJustFileName;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.JustFileName([APath]);');
      TObj := TStringClass.Create;
      TObj.JustFileName([APath]);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoJustName;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.JustName([APath]);');
      TObj := TStringClass.Create;
      TObj.JustName([APath]);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoJustDirectory;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.JustDirectory([APath]);');
      TObj := TStringClass.Create;
      TObj.JustDirectory([APath]);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoReplaceAll;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([AStr,'' '',APChar]);');
      Writeln('TObj.ReplaceAll([''string''],[''text'']);');
      TObj := TStringClass.CreateString([AStr,' ',APChar]);
      TObj.ReplaceAll(['string'],['text']);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoParseDelimToList;
   VAR
      TObj : TStringClass;
      AList : TObjectContainer;

      { ++++++++++++++++++++++++++++++++++++++++++++++ }

      PROCEDURE WrSub(S : TStringClass); FAR;
      BEGIN
         Writeln(S.ZString);
      END;

      { ++++++++++++++++++++++++++++++++++++++++++++++ }

   BEGIN
      Writeln('Code:');
      Writeln('AList := TObjectContainer.Create;');
      Writeln('AList.Capacity := 100;');
      Writeln('TObj := TStringClass.CreateString([''xxx,yyy,zzzz,wwww,,qqqq,rrrr'']);');
      Writeln('TObj.ParseDelimToList('','',delim_None,AList);');
      Writeln('AList.ForEach(@WrSub);');
      AList := TObjectContainer.Create;
      AList.Capacity := 100;
      TObj := TStringClass.CreateString(['xxx,yyy,zzzz,wwww,,qqqq,rrrr']);
      TObj.ParseDelimToList(',',delim_None,AList);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      Writeln('Parsed sub strings ...');
      AList.ForEach(@WrSub);
      TObj.Free;
      AList.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoDirectoryExists;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([APath]);');
      Writeln('B := TObj.DirectoryExists;');
      TObj := TStringClass.CreateString([APath]);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      Write('Directory ');
      IF TObj.DirectoryExists THEN
         Writeln('exists')
      ELSE
         Writeln('does not exist');
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoFindCurrentDir;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.Create;');
      Writeln('TObj.FindCurrentDir;');
      TObj := TStringClass.Create;
      TObj.FindCurrentDir;
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoFileExists;
   VAR
      TObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('TObj := TStringClass.CreateString([APath]);');
      TObj := TStringClass.CreateString([APath]);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      Write('File ');
      IF TObj.FileExists THEN
         Writeln('exists')
      ELSE
         Writeln('does not exist');
      TObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   PROCEDURE DoFileSplit;
   VAR
      TObj,DObj,NObj,EObj : TStringClass;
   BEGIN
      Writeln('Code:');
      Writeln('DObj := TStringClass.Create;');
      Writeln('NObj := TStringClass.Create;');
      Writeln('EObj := TStringClass.Create;');
      Writeln('TObj := TStringClass.CreateString([APath]);');
      Writeln('TObj.FileSplit(DObj,NObj,EObj);');
      DObj := TStringClass.Create;
      NObj := TStringClass.Create;
      EObj := TStringClass.Create;
      TObj := TStringClass.CreateString([APath]);
      TObj.FileSplit(DObj,NObj,EObj);
      Writeln;
      Writeln('Result:');
      Writeln(TObj.ZString);
      Writeln(DObj.ZString);
      Writeln(NObj.ZString);
      Writeln(EObj.ZString);
      TObj.Free;
      DObj.Free;
      NObj.Free;
      EObj.Free;
   END;

   { +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

BEGIN
   ANullStrObj := TStringClass.Create;
   AStrObj := TStringClass.CreateString(['TStringClass string']);
   OutConsole.ClrScr;
   CASE fid OF
      id_Create :
         DoCreate;
      id_CreateSize :
         DoCreateSize;
      id_CreateString :
         DoCreateString;
      id_CreateStringNL :
         DoCreateStringNL;
      id_CreateBoolean :
         DoCreateBoolean;
      id_Destroy :
         DoDestroy;
      id_Copy :
         DoCopy;
      id_CopyFrom :
         DoCopyFrom;
      id_Clear :
         DoClear;
      id_Empty :
         DoEmpty;
      id_Assign :
         DoAssign;
      id_AssignFrom :
         DoAssignFrom;
      id_AssignLen :
         DoAssignLen;
      id_AssignMid :
         DoAssignMid;
      id_AssignNL :
         DoAssignNL;
      id_AssignPad :
         DoAssignPad;
      id_AssignRight :
         DoAssignRight;
      id_AssignTrim :
         DoAssignTrim;
      id_Append :
         DoAppend;
      id_AppendBoolean :
         DoAppendBoolean;
      id_AppendByte :
         DoAppendByte;
      id_AppendCh :
         DoAppendCh;
      id_AppendDIC :
         DoAppendDIC;
      id_AppendDouble :
         DoAppendDouble;
      id_AppendDoubleTrim :
         DoAppendDoubleTrim;
      id_AppendExt :
         DoAppendExt;
      id_AppendExtTrim :
         DoAppendExtTrim;
      id_AppendLen :
         DoAppendLen;
      id_AppendLong :
         DoAppendLong;
      id_AppendMid :
         DoAppendMid;
      id_AppendNL :
         DoAppendNL;
      id_AppendPad :
         DoAppendPad;
      id_AppendPtr :
         DoAppendPtr;
      id_AppendReal :
         DoAppendReal;
      id_AppendRight :
         DoAppendRight;
      id_AppendSIC :
         DoAppendSIC;
      id_AppendTrim :
         DoAppendTrim;
      id_AppendWithTab :
         DoAppendWithTab;
      id_NLAppend :
         DoNLAppend;
      id_Prepend :
         DoPrepend;
      id_FirstNonSpaceCh :
          DoFirstNonSpaceCh;
      id_HasCh :
         DoHasCh;
      id_isCh :
         DoIsCh;
          (*
      id_IsFirstCh = 44;
      id_IsLastCh = 45;
      id_LastNonSpaceCh = 46;
      id_RemoveLastCh = 47;
      id_SetCh = 48;
      id_FromBoolean = 49;
      id_FromByte = 50;
      id_FromChar = 51;
      id_FromDouble = 52;
      id_FromDoubleTrim = 53;
      id_FromExt = 54;
      id_FromExtTrim  = 55;
      id_FromLong = 56;
      id_FromPtr = 57;
      id_FromReal = 58;
      id_FromRealTrim = 59;
      *)
      id_FromRGB :
         DoFromRGB;
         (*
      id_HexFromByte = 61;
      id_HexFromLong = 62;
      id_HexFromPtr = 63;
      id_HexFromWord = 64;
      id_ToBoolean = 65;
      id_ToByte = 66;
      id_ToChar = 67;
      id_ToDouble = 68;
      id_ToExt = 69;
      id_ToInteger = 70;
      id_ToLong = 71;
      id_ToReal = 72;
      id_ToRGB = 73;
      id_ToWord = 74;
      id_AppendStr = 75;
      id_UpperCase = 76;
      id_LowerCase = 77;
      id_CompareStr = 78;
      id_CompareText = 79;
      id_AnsiUpperCase = 80;
      id_AnsiLowerCase = 81;
      id_AnsiCompareStr = 82;
      id_AnsiCompareText = 83;
      id_IsValidIdent = 84;
      id_IntToStr = 85;
      id_IntToHex = 86;
      id_StrToInt = 87;
      id_StrToIntDef = 88;
      id_LoadStr = 89;
      id_FmtLoadStr = 90;
      id_Format = 91;
      id_FloatToStr = 92;
      id_FloatToStrF = 93;
      id_FormatFloat = 94;
      id_StrToFloat = 95;
      id_StrCat = 96;
      id_StrComp = 97;
      id_StrCopy = 98;
      id_StrECopy = 99;
      id_StrEnd = 100;
      id_StrIComp = 101;
      id_StrLCat = 102;
      id_StrLIComp = 103;
      id_StrLComp = 104;
      id_StrLCopy = 105;
      id_StrLen = 106;
      id_StrLower = 107;
      id_StrMove = 108;
      id_StrPas = 109;
      id_StrPCopy = 110;
      id_StrPos = 111;
      id_StrRScan = 112;
      id_StrScan = 113;
      id_StrUpper = 114;
      id_Compare = 115;
      id_CompareI = 116;
      id_CompareL = 117;
      id_CompareLI = 118;
      id_CompareLong = 119;
      id_CompareDouble = 120;
      id_CompareExt = 121;
      id_IsSame = 122;
      id_IsSameI = 122;
      id_isSameL = 123;
      id_IsSameLI = 124;
      id_Includes = 125;
      id_Within = 126;
      id_Delete = 127;
      id_Insert = 128;
      id_InsertL = 129;
      id_PadCentre = 130;
      id_PadEnd = 131;
      id_PadFront = 132;
      id_RemoveDIC = 133;
      id_RemoveSIC = 134;
      id_Trim = 135;
      id_TrimEnd = 136;
      id_TrimFront = 137;
      id_TrimZero = 138;
      *)
      id_FindCmdLine :
         DoFindCmdLine;
      (*
      id_FindCmdLineAndParse = 140;
      id_FindCmdLineParam = 141;
      id_AppendStringRes = 142;
      id_LoadStringRes = 143;
      id_ReadIniKeyword = 144;
      id_WriteIniKeyword = 145;
      id_FindIniSectionKeywords = 146;
      id_AddBackSlash = 147;
      id_BuildPathName = 148;
      id_DefaultExtension = 149;
      id_ExpandFileName = 150;
      id_ForceExtension = 151;
      id_HasBackSlash = 152;
      id_HasDrive = 153;
      id_HasExtension = 154;
      id_HasFileName = 155;
      id_HasDirectory = 156;
      *)
      id_FindCurrentDir :
         DoFindCurrentDir;
      id_DirectoryExists :
         DoDirectoryExists;
      (*
      id_DriveExists = 158;
      *)
      id_FileExists :
         DoFileExists;
      id_FileSplit :
         DoFileSplit;
      id_JustExtension :
         DoJustExtension;
      id_JustFileName :
         DoJustFileName;
      id_JustName :
         DoJustName;
      id_JustDirectory :
         DoJustDirectory;
         (*
      id_SetCurDir = 163;
      id_ChCount = 164;
      id_FindBetween2Ch = 165;
      id_FindFirst = 166;
      id_FindFirstCh = 167;
      id_FindLast = 168;
      id_FindLastCh = 169;
      id_FindNext = 170;
      id_FindNextCh = 171;
      id_FindPrev = 172;
      id_FindPrevCh = 173;
      id_SubStrCount = 174;
      id_FirstCharToUpper = 175;
      id_IsAlphaNumeric = 176;
      id_ToLower = 177;
      id_ToUpper = 178;
      *)
      id_ReplaceAll :
         DoReplaceAll;
      (*
      id_ReplaceFirst = 180;
      id_ReplaceLast = 181;
      id_ReplaceChAll = 182;
      id_ReplaceChFirst = 183;
      id_ReplaceChLast = 184;
      id_FirstParseDelim = 185;
      id_NextParseDelim = 186;
      id_ParseDelimCount = 187;
      *)
      id_ParseDelimToList :
         DoParseDelimToList;
      (*
      id_ParsePosToList = 189;
      *)

   END;
   { scroll to top }
   OutConsole.ScrollTo(0,0);
END;
{ :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

end.
