unit FiltProp;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Bitbox, TypInfo, Buttons, Toolbar, ExtCtrls;

type
  TFiltPropForm = class(TForm)
    BitBox1: TBitBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Toolbar1: TToolbar;
    VarsButton: TToolButton;
    ClassesButton: TToolButton;
    MethodsButton: TToolButton;
    AllButton: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure AllButtonClick(Sender: TObject);
    procedure VarsButtonClick(Sender: TObject);
    procedure ClassesButtonClick(Sender: TObject);
    procedure MethodsButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FiltPropForm: TFiltPropForm;

implementation

uses DocProps;

{$R *.DFM}

procedure TFiltPropForm.FormCreate(Sender: TObject);
var
  aKind:TTypeKind;
  k:TTypeKinds;
begin
  with BitBox1 do begin
    Captions.Clear;
    K:=[];
    for aKind:=low(TTypeKind) to high(TTypeKind) do begin
      K:=K + [aKind];
      Captions.Add(GetEnumName(TypeInfo(TTypeKind),ord(aKind))^);
      end;
    Possible:=TWordSet(k);
    end;
end;

procedure TFiltPropForm.AllButtonClick(Sender: TObject);
begin
  BitBox1.Possible:=TWordSet(AllFilter);
end;

procedure TFiltPropForm.VarsButtonClick(Sender: TObject);
begin
  BitBox1.Possible:=TWordSet(VarFilter);
end;

procedure TFiltPropForm.ClassesButtonClick(Sender: TObject);
begin
  BitBox1.Possible:=TWordSet(ClassFilter);
end;

procedure TFiltPropForm.MethodsButtonClick(Sender: TObject);
begin
  BitBox1.Possible:=TWordSet(MethodFilter);
end;

end.
